package lab04;

import javax.swing.JOptionPane;

public class Quiz implements QuestionResponseEventHandler {
	private String[] questions;
	private String[][] answers;
	private int[] correct;

	private int answerCorrect;
	private int currentQuestion;

	public Quiz(String[] questions, String[][] answers, int[] correct) {
		this.questions = questions;
		this.answers = answers;
		this.correct = correct;

		this.answerCorrect = 0;
		this.currentQuestion = -1;
	}

	public boolean start() {
		if (this.currentQuestion == -1) {
			this.nextQuestion();
			return true;
		}

		return false;
	}

	private void nextQuestion() {
		this.currentQuestion++;

		if (this.currentQuestion >= this.questions.length) {
			this.finishQuiz();
			return;
		}

		try {
			new Question(this.currentQuestion + 1, this.questions[this.currentQuestion],
					this.answers[this.currentQuestion], this.correct[this.currentQuestion], this);
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "ERROR: Invalid question: " + e.getMessage());
			this.nextQuestion();
		}
	}

	private void finishQuiz() {
		JOptionPane.showMessageDialog(null,
				"Correct answers: " + String.valueOf(this.answerCorrect) + "/" + String.valueOf(this.questions.length)
						+ "   |   " + String.valueOf(this.answerCorrect * 100 / this.questions.length) + "%",
				"Quiz completed!", JOptionPane.QUESTION_MESSAGE);
	}

	@Override
	public void onResponse(boolean isCorrect) {
		if (isCorrect) {
			this.answerCorrect++;
		}

		this.nextQuestion();
	}
}
